<center><a href="rk.c">Actual source code: rk.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:32:04+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCTS_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*</font>
<a name="line4">  4: </a><font color="#B22222"> * Code for Timestepping with Runge Kutta</font>
<a name="line5">  5: </a><font color="#B22222"> *</font>
<a name="line6">  6: </a><font color="#B22222"> * Written by</font>
<a name="line7">  7: </a><font color="#B22222"> * Asbjorn Hoiland Aarrestad</font>
<a name="line8">  8: </a><font color="#B22222"> * asbjorn@aarrestad.com</font>
<a name="line9">  9: </a><font color="#B22222"> * http://asbjorn.aarrestad.com/</font>
<a name="line10"> 10: </a><font color="#B22222"> * </font>
<a name="line11"> 11: </a><font color="#B22222"> */</font>
<a name="line12"> 12: </a> #include <A href="../../../../../src/ts/tsimpl.h.html">src/ts/tsimpl.h</A>
<a name="line13"> 13: </a><font color="#A020F0">#include </font><font color="#666666">"time.h"</font><font color="#A020F0"></font>

<a name="line15"> 15: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line16"> 16: </a>   <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>          y1,y2;  <font color="#B22222">/* work wectors for the two rk permuations */</font>
<a name="line17"> 17: </a>   <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>     nok,nnok; <font color="#B22222">/* counters for ok and not ok steps */</font>
<a name="line18"> 18: </a>   <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>    maxerror; <font color="#B22222">/* variable to tell the maxerror allowed */</font>
<a name="line19"> 19: </a>   <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>    ferror; <font color="#B22222">/* variable to tell (global maxerror)/(total time) */</font>
<a name="line20"> 20: </a>   <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>    tolerance; <font color="#B22222">/* initial value set for maxerror by user */</font>
<a name="line21"> 21: </a>   <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>          tmp,tmp_y,*k; <font color="#B22222">/* two temp vectors and the k vectors for rk */</font>
<a name="line22"> 22: </a>   <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  a[7][6]; <font color="#B22222">/* rk scalars */</font>
<a name="line23"> 23: </a>   <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  b1[7],b2[7]; <font color="#B22222">/* rk scalars */</font>
<a name="line24"> 24: </a>   <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>    c[7]; <font color="#B22222">/* rk scalars */</font>
<a name="line25"> 25: </a>   <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>     p,s; <font color="#B22222">/* variables to tell the <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> of the runge-kutta solver */</font>
<a name="line26"> 26: </a>} TS_Rk;

<a name="line31"> 31: </a><strong><font color="#4169E1"><a name="TSRKSetTolerance_RK"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  TSRKSetTolerance_RK(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> aabs)</font></strong>
<a name="line32"> 32: </a>{
<a name="line33"> 33: </a>  TS_Rk *rk = (TS_Rk*)ts-&gt;data;
<a name="line34"> 34: </a>
<a name="line36"> 36: </a>  rk-&gt;tolerance = aabs;
<a name="line37"> 37: </a>  <font color="#4169E1">return</font>(0);
<a name="line38"> 38: </a>}

<a name="line43"> 43: </a><font color="#B22222">/*@</font>
<a name="line44"> 44: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/TS/TSRKSetTolerance.html#TSRKSetTolerance">TSRKSetTolerance</A> - Sets the total error the RK explicit time integrators </font>
<a name="line45"> 45: </a><font color="#B22222">                      will allow over the given time interval.</font>

<a name="line47"> 47: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A></font>

<a name="line49"> 49: </a><font color="#B22222">   Input parameters:</font>
<a name="line50"> 50: </a><font color="#B22222">+    ts  - the time-step context</font>
<a name="line51"> 51: </a><font color="#B22222">-    aabs - the absolute tolerance  </font>

<a name="line53"> 53: </a><font color="#B22222">   Level: intermediate</font>

<a name="line55"> 55: </a><font color="#B22222">.keywords: RK, tolerance</font>

<a name="line57"> 57: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/TS/TSSundialsSetTolerance.html#TSSundialsSetTolerance">TSSundialsSetTolerance</A>()</font>

<a name="line59"> 59: </a><font color="#B22222">@*/</font>
<a name="line60"> 60: </a><strong><font color="#4169E1"><a name="TSRKSetTolerance"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/TS/TSRKSetTolerance.html#TSRKSetTolerance">TSRKSetTolerance</A>(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> aabs)</font></strong>
<a name="line61"> 61: </a>{
<a name="line62"> 62: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>);
<a name="line63"> 63: </a>
<a name="line65"> 65: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)ts,<font color="#666666">"TSRKSetTolerance_C"</font>,(void (**)(void))&amp;f);
<a name="line66"> 66: </a>  <font color="#4169E1">if</font> (f) {
<a name="line67"> 67: </a>    (*f)(ts,aabs);
<a name="line68"> 68: </a>  }
<a name="line69"> 69: </a>  <font color="#4169E1">return</font>(0);
<a name="line70"> 70: </a>}


<a name="line75"> 75: </a><strong><font color="#4169E1"><a name="TSSetUp_Rk"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSSetUp_Rk(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line76"> 76: </a>{
<a name="line77"> 77: </a>  TS_Rk          *rk = (TS_Rk*)ts-&gt;data;

<a name="line81"> 81: </a>  rk-&gt;nok      = 0;
<a name="line82"> 82: </a>  rk-&gt;nnok     = 0;
<a name="line83"> 83: </a>  rk-&gt;maxerror = rk-&gt;tolerance;

<a name="line85"> 85: </a>  <font color="#B22222">/* fixing maxerror: global vs local */</font>
<a name="line86"> 86: </a>  rk-&gt;ferror = rk-&gt;maxerror / (ts-&gt;max_time - ts-&gt;ptime);

<a name="line88"> 88: </a>  <font color="#B22222">/* 34.0/45.0 gives double precision division */</font>
<a name="line89"> 89: </a>  <font color="#B22222">/* defining variables needed for Runge-Kutta computing */</font>
<a name="line90"> 90: </a>  <font color="#B22222">/* when changing below, please remember to change a, b1, b2 and c above! */</font>
<a name="line91"> 91: </a>  <font color="#B22222">/* Found in table on page 171: Dormand-Prince 5(4) */</font>

<a name="line93"> 93: </a>  <font color="#B22222">/* are these right? */</font>
<a name="line94"> 94: </a>  rk-&gt;p=6;
<a name="line95"> 95: </a>  rk-&gt;s=7;

<a name="line97"> 97: </a>  rk-&gt;a[1][0]=1.0/5.0;
<a name="line98"> 98: </a>  rk-&gt;a[2][0]=3.0/40.0;
<a name="line99"> 99: </a>  rk-&gt;a[2][1]=9.0/40.0;
<a name="line100">100: </a>  rk-&gt;a[3][0]=44.0/45.0;
<a name="line101">101: </a>  rk-&gt;a[3][1]=-56.0/15.0;
<a name="line102">102: </a>  rk-&gt;a[3][2]=32.0/9.0;
<a name="line103">103: </a>  rk-&gt;a[4][0]=19372.0/6561.0;
<a name="line104">104: </a>  rk-&gt;a[4][1]=-25360.0/2187.0;
<a name="line105">105: </a>  rk-&gt;a[4][2]=64448.0/6561.0;
<a name="line106">106: </a>  rk-&gt;a[4][3]=-212.0/729.0;
<a name="line107">107: </a>  rk-&gt;a[5][0]=9017.0/3168.0;
<a name="line108">108: </a>  rk-&gt;a[5][1]=-355.0/33.0;
<a name="line109">109: </a>  rk-&gt;a[5][2]=46732.0/5247.0;
<a name="line110">110: </a>  rk-&gt;a[5][3]=49.0/176.0;
<a name="line111">111: </a>  rk-&gt;a[5][4]=-5103.0/18656.0;
<a name="line112">112: </a>  rk-&gt;a[6][0]=35.0/384.0;
<a name="line113">113: </a>  rk-&gt;a[6][1]=0.0;
<a name="line114">114: </a>  rk-&gt;a[6][2]=500.0/1113.0;
<a name="line115">115: </a>  rk-&gt;a[6][3]=125.0/192.0;
<a name="line116">116: </a>  rk-&gt;a[6][4]=-2187.0/6784.0;
<a name="line117">117: </a>  rk-&gt;a[6][5]=11.0/84.0;


<a name="line120">120: </a>  rk-&gt;c[0]=0.0;
<a name="line121">121: </a>  rk-&gt;c[1]=1.0/5.0;
<a name="line122">122: </a>  rk-&gt;c[2]=3.0/10.0;
<a name="line123">123: </a>  rk-&gt;c[3]=4.0/5.0;
<a name="line124">124: </a>  rk-&gt;c[4]=8.0/9.0;
<a name="line125">125: </a>  rk-&gt;c[5]=1.0;
<a name="line126">126: </a>  rk-&gt;c[6]=1.0;
<a name="line127">127: </a>
<a name="line128">128: </a>  rk-&gt;b1[0]=35.0/384.0;
<a name="line129">129: </a>  rk-&gt;b1[1]=0.0;
<a name="line130">130: </a>  rk-&gt;b1[2]=500.0/1113.0;
<a name="line131">131: </a>  rk-&gt;b1[3]=125.0/192.0;
<a name="line132">132: </a>  rk-&gt;b1[4]=-2187.0/6784.0;
<a name="line133">133: </a>  rk-&gt;b1[5]=11.0/84.0;
<a name="line134">134: </a>  rk-&gt;b1[6]=0.0;

<a name="line136">136: </a>  rk-&gt;b2[0]=5179.0/57600.0;
<a name="line137">137: </a>  rk-&gt;b2[1]=0.0;
<a name="line138">138: </a>  rk-&gt;b2[2]=7571.0/16695.0;
<a name="line139">139: </a>  rk-&gt;b2[3]=393.0/640.0;
<a name="line140">140: </a>  rk-&gt;b2[4]=-92097.0/339200.0;
<a name="line141">141: </a>  rk-&gt;b2[5]=187.0/2100.0;
<a name="line142">142: </a>  rk-&gt;b2[6]=1.0/40.0;
<a name="line143">143: </a>
<a name="line144">144: </a>
<a name="line145">145: </a>  <font color="#B22222">/* Found in table on page 170: Fehlberg 4(5) */</font>
<a name="line146">146: </a>  <font color="#B22222">/*  </font>
<a name="line147">147: </a><font color="#B22222">  rk-&gt;p=5;</font>
<a name="line148">148: </a><font color="#B22222">  rk-&gt;s=6;</font>

<a name="line150">150: </a><font color="#B22222">  rk-&gt;a[1][0]=1.0/4.0;</font>
<a name="line151">151: </a><font color="#B22222">  rk-&gt;a[2][0]=3.0/32.0;</font>
<a name="line152">152: </a><font color="#B22222">  rk-&gt;a[2][1]=9.0/32.0;</font>
<a name="line153">153: </a><font color="#B22222">  rk-&gt;a[3][0]=1932.0/2197.0;</font>
<a name="line154">154: </a><font color="#B22222">  rk-&gt;a[3][1]=-7200.0/2197.0;</font>
<a name="line155">155: </a><font color="#B22222">  rk-&gt;a[3][2]=7296.0/2197.0;</font>
<a name="line156">156: </a><font color="#B22222">  rk-&gt;a[4][0]=439.0/216.0;</font>
<a name="line157">157: </a><font color="#B22222">  rk-&gt;a[4][1]=-8.0;</font>
<a name="line158">158: </a><font color="#B22222">  rk-&gt;a[4][2]=3680.0/513.0;</font>
<a name="line159">159: </a><font color="#B22222">  rk-&gt;a[4][3]=-845.0/4104.0;</font>
<a name="line160">160: </a><font color="#B22222">  rk-&gt;a[5][0]=-8.0/27.0;</font>
<a name="line161">161: </a><font color="#B22222">  rk-&gt;a[5][1]=2.0;</font>
<a name="line162">162: </a><font color="#B22222">  rk-&gt;a[5][2]=-3544.0/2565.0;</font>
<a name="line163">163: </a><font color="#B22222">  rk-&gt;a[5][3]=1859.0/4104.0;</font>
<a name="line164">164: </a><font color="#B22222">  rk-&gt;a[5][4]=-11.0/40.0;</font>

<a name="line166">166: </a><font color="#B22222">  rk-&gt;c[0]=0.0;</font>
<a name="line167">167: </a><font color="#B22222">  rk-&gt;c[1]=1.0/4.0;</font>
<a name="line168">168: </a><font color="#B22222">  rk-&gt;c[2]=3.0/8.0;</font>
<a name="line169">169: </a><font color="#B22222">  rk-&gt;c[3]=12.0/13.0;</font>
<a name="line170">170: </a><font color="#B22222">  rk-&gt;c[4]=1.0;</font>
<a name="line171">171: </a><font color="#B22222">  rk-&gt;c[5]=1.0/2.0;</font>

<a name="line173">173: </a><font color="#B22222">  rk-&gt;b1[0]=25.0/216.0;</font>
<a name="line174">174: </a><font color="#B22222">  rk-&gt;b1[1]=0.0;</font>
<a name="line175">175: </a><font color="#B22222">  rk-&gt;b1[2]=1408.0/2565.0;</font>
<a name="line176">176: </a><font color="#B22222">  rk-&gt;b1[3]=2197.0/4104.0;</font>
<a name="line177">177: </a><font color="#B22222">  rk-&gt;b1[4]=-1.0/5.0;</font>
<a name="line178">178: </a><font color="#B22222">  rk-&gt;b1[5]=0.0;</font>
<a name="line179">179: </a><font color="#B22222">  </font>
<a name="line180">180: </a><font color="#B22222">  rk-&gt;b2[0]=16.0/135.0;</font>
<a name="line181">181: </a><font color="#B22222">  rk-&gt;b2[1]=0.0;</font>
<a name="line182">182: </a><font color="#B22222">  rk-&gt;b2[2]=6656.0/12825.0;</font>
<a name="line183">183: </a><font color="#B22222">  rk-&gt;b2[3]=28561.0/56430.0;</font>
<a name="line184">184: </a><font color="#B22222">  rk-&gt;b2[4]=-9.0/50.0;</font>
<a name="line185">185: </a><font color="#B22222">  rk-&gt;b2[5]=2.0/55.0;</font>
<a name="line186">186: </a><font color="#B22222">  */</font>
<a name="line187">187: </a>  <font color="#B22222">/* Found in table on page 169: Merson 4("5") */</font>
<a name="line188">188: </a>  <font color="#B22222">/*</font>
<a name="line189">189: </a><font color="#B22222">  rk-&gt;p=4;</font>
<a name="line190">190: </a><font color="#B22222">  rk-&gt;s=5;</font>
<a name="line191">191: </a><font color="#B22222">  rk-&gt;a[1][0] = 1.0/3.0;</font>
<a name="line192">192: </a><font color="#B22222">  rk-&gt;a[2][0] = 1.0/6.0;</font>
<a name="line193">193: </a><font color="#B22222">  rk-&gt;a[2][1] = 1.0/6.0;</font>
<a name="line194">194: </a><font color="#B22222">  rk-&gt;a[3][0] = 1.0/8.0;</font>
<a name="line195">195: </a><font color="#B22222">  rk-&gt;a[3][1] = 0.0;</font>
<a name="line196">196: </a><font color="#B22222">  rk-&gt;a[3][2] = 3.0/8.0;</font>
<a name="line197">197: </a><font color="#B22222">  rk-&gt;a[4][0] = 1.0/2.0;</font>
<a name="line198">198: </a><font color="#B22222">  rk-&gt;a[4][1] = 0.0;</font>
<a name="line199">199: </a><font color="#B22222">  rk-&gt;a[4][2] = -3.0/2.0;</font>
<a name="line200">200: </a><font color="#B22222">  rk-&gt;a[4][3] = 2.0;</font>

<a name="line202">202: </a><font color="#B22222">  rk-&gt;c[0] = 0.0;</font>
<a name="line203">203: </a><font color="#B22222">  rk-&gt;c[1] = 1.0/3.0;</font>
<a name="line204">204: </a><font color="#B22222">  rk-&gt;c[2] = 1.0/3.0;</font>
<a name="line205">205: </a><font color="#B22222">  rk-&gt;c[3] = 0.5;</font>
<a name="line206">206: </a><font color="#B22222">  rk-&gt;c[4] = 1.0;</font>

<a name="line208">208: </a><font color="#B22222">  rk-&gt;b1[0] = 1.0/2.0;</font>
<a name="line209">209: </a><font color="#B22222">  rk-&gt;b1[1] = 0.0;</font>
<a name="line210">210: </a><font color="#B22222">  rk-&gt;b1[2] = -3.0/2.0;</font>
<a name="line211">211: </a><font color="#B22222">  rk-&gt;b1[3] = 2.0;</font>
<a name="line212">212: </a><font color="#B22222">  rk-&gt;b1[4] = 0.0;</font>

<a name="line214">214: </a><font color="#B22222">  rk-&gt;b2[0] = 1.0/6.0;</font>
<a name="line215">215: </a><font color="#B22222">  rk-&gt;b2[1] = 0.0;</font>
<a name="line216">216: </a><font color="#B22222">  rk-&gt;b2[2] = 0.0;</font>
<a name="line217">217: </a><font color="#B22222">  rk-&gt;b2[3] = 2.0/3.0;</font>
<a name="line218">218: </a><font color="#B22222">  rk-&gt;b2[4] = 1.0/6.0;</font>
<a name="line219">219: </a><font color="#B22222">  */</font>

<a name="line221">221: </a>  <font color="#B22222">/* making b2 -&gt; e=b1-b2 */</font>
<a name="line222">222: </a>  <font color="#B22222">/*</font>
<a name="line223">223: </a><font color="#B22222">    for(i=0;i&lt;rk-&gt;s;i++){</font>
<a name="line224">224: </a><font color="#B22222">     rk-&gt;b2[i] = (rk-&gt;b1[i]) - (rk-&gt;b2[i]);</font>
<a name="line225">225: </a><font color="#B22222">  }</font>
<a name="line226">226: </a><font color="#B22222">  */</font>
<a name="line227">227: </a>  rk-&gt;b2[0]=71.0/57600.0;
<a name="line228">228: </a>  rk-&gt;b2[1]=0.0;
<a name="line229">229: </a>  rk-&gt;b2[2]=-71.0/16695.0;
<a name="line230">230: </a>  rk-&gt;b2[3]=71.0/1920.0;
<a name="line231">231: </a>  rk-&gt;b2[4]=-17253.0/339200.0;
<a name="line232">232: </a>  rk-&gt;b2[5]=22.0/525.0;
<a name="line233">233: </a>  rk-&gt;b2[6]=-1.0/40.0;

<a name="line235">235: </a>  <font color="#B22222">/* initializing vectors */</font>
<a name="line236">236: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(ts-&gt;vec_sol,&amp;rk-&gt;y1);
<a name="line237">237: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(ts-&gt;vec_sol,&amp;rk-&gt;y2);
<a name="line238">238: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(rk-&gt;y1,&amp;rk-&gt;tmp);
<a name="line239">239: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(rk-&gt;y1,&amp;rk-&gt;tmp_y);
<a name="line240">240: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicateVecs.html#VecDuplicateVecs">VecDuplicateVecs</A>(rk-&gt;y1,rk-&gt;s,&amp;rk-&gt;k);

<a name="line242">242: </a>  <font color="#4169E1">return</font>(0);
<a name="line243">243: </a>}

<a name="line245">245: </a><font color="#B22222">/*------------------------------------------------------------*/</font>
<a name="line248">248: </a><strong><font color="#4169E1"><a name="TSRkqs"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSRkqs(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> t,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> h)</font></strong>
<a name="line249">249: </a>{
<a name="line250">250: </a>  TS_Rk          *rk = (TS_Rk*)ts-&gt;data;
<a name="line252">252: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       j,l;
<a name="line253">253: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      tmp_t=t;
<a name="line254">254: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    hh=h;

<a name="line257">257: </a>  <font color="#B22222">/* k[0]=0  */</font>
<a name="line258">258: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(rk-&gt;k[0],0.0);
<a name="line259">259: </a>
<a name="line260">260: </a>  <font color="#B22222">/* k[0] = derivs(t,y1) */</font>
<a name="line261">261: </a>  TSComputeRHSFunction(ts,t,rk-&gt;y1,rk-&gt;k[0]);
<a name="line262">262: </a>  <font color="#B22222">/* looping over runge-kutta variables */</font>
<a name="line263">263: </a>  <font color="#B22222">/* building the k - array of vectors */</font>
<a name="line264">264: </a>  <font color="#4169E1">for</font>(j = 1 ; j &lt; rk-&gt;s ; j++){

<a name="line266">266: </a>     <font color="#B22222">/* rk-&gt;tmp = 0 */</font>
<a name="line267">267: </a>     <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(rk-&gt;tmp,0.0);

<a name="line269">269: </a>     <font color="#4169E1">for</font>(l=0;l&lt;j;l++){
<a name="line270">270: </a>        <font color="#B22222">/* tmp += a(j,l)*k[l] */</font>
<a name="line271">271: </a>       <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(rk-&gt;tmp,rk-&gt;a[j][l],rk-&gt;k[l]);
<a name="line272">272: </a>     }

<a name="line274">274: </a>     <font color="#B22222">/* <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(rk-&gt;tmp,<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>); */</font>
<a name="line275">275: </a>
<a name="line276">276: </a>     <font color="#B22222">/* k[j] = derivs(t+c(j)*h,y1+h*tmp,k(j)) */</font>
<a name="line277">277: </a>     <font color="#B22222">/* I need the following helpers:</font>
<a name="line278">278: </a><font color="#B22222">        <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  tmp_t=t+c(j)*h</font>
<a name="line279">279: </a><font color="#B22222">        <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>          tmp_y=h*tmp+y1</font>
<a name="line280">280: </a><font color="#B22222">     */</font>

<a name="line282">282: </a>     tmp_t = t + rk-&gt;c[j] * h;

<a name="line284">284: </a>     <font color="#B22222">/* tmp_y = h * tmp + y1 */</font>
<a name="line285">285: </a>     <A href="../../../../../docs/manualpages/Vec/VecWAXPY.html#VecWAXPY">VecWAXPY</A>(rk-&gt;tmp_y,hh,rk-&gt;tmp,rk-&gt;y1);

<a name="line287">287: </a>     <font color="#B22222">/* rk-&gt;k[j]=0 */</font>
<a name="line288">288: </a>     <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(rk-&gt;k[j],0.0);
<a name="line289">289: </a>     TSComputeRHSFunction(ts,tmp_t,rk-&gt;tmp_y,rk-&gt;k[j]);
<a name="line290">290: </a>  }

<a name="line292">292: </a>  <font color="#B22222">/* tmp=0 and tmp_y=0 */</font>
<a name="line293">293: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(rk-&gt;tmp,0.0);
<a name="line294">294: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(rk-&gt;tmp_y,0.0);
<a name="line295">295: </a>
<a name="line296">296: </a>  <font color="#4169E1">for</font>(j = 0 ; j &lt; rk-&gt;s ; j++){
<a name="line297">297: </a>     <font color="#B22222">/* tmp=b1[j]*k[j]+tmp  */</font>
<a name="line298">298: </a>    <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(rk-&gt;tmp,rk-&gt;b1[j],rk-&gt;k[j]);
<a name="line299">299: </a>     <font color="#B22222">/* tmp_y=b2[j]*k[j]+tmp_y */</font>
<a name="line300">300: </a>    <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(rk-&gt;tmp_y,rk-&gt;b2[j],rk-&gt;k[j]);
<a name="line301">301: </a>  }

<a name="line303">303: </a>  <font color="#B22222">/* y2 = hh * tmp_y */</font>
<a name="line304">304: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(rk-&gt;y2,0.0);
<a name="line305">305: </a>  <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(rk-&gt;y2,hh,rk-&gt;tmp_y);
<a name="line306">306: </a>  <font color="#B22222">/* y1 = hh*tmp + y1 */</font>
<a name="line307">307: </a>  <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(rk-&gt;y1,hh,rk-&gt;tmp);
<a name="line308">308: </a>  <font color="#B22222">/* Finding difference between y1 and y2 */</font>
<a name="line309">309: </a>  <font color="#4169E1">return</font>(0);
<a name="line310">310: </a>}

<a name="line314">314: </a><strong><font color="#4169E1"><a name="TSStep_Rk"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSStep_Rk(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *steps,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *ptime)</font></strong>
<a name="line315">315: </a>{
<a name="line316">316: </a>  TS_Rk          *rk = (TS_Rk*)ts-&gt;data;
<a name="line318">318: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      norm=0.0,dt_fac=0.0,fac = 0.0<font color="#B22222">/*,ttmp=0.0*/</font>;

<a name="line321">321: </a>  ierr=<A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(ts-&gt;vec_sol,rk-&gt;y1);
<a name="line322">322: </a>  *steps = -ts-&gt;steps;
<a name="line323">323: </a>  <font color="#B22222">/* trying to save the vector */</font>
<a name="line324">324: </a>  TSMonitor(ts,ts-&gt;steps,ts-&gt;ptime,ts-&gt;vec_sol);
<a name="line325">325: </a>  <font color="#B22222">/* while loop to get from start to stop */</font>
<a name="line326">326: </a>  <font color="#4169E1">while</font> (ts-&gt;ptime &lt; ts-&gt;max_time){
<a name="line327">327: </a>   <font color="#B22222">/* calling rkqs */</font>
<a name="line328">328: </a>     <font color="#B22222">/*</font>
<a name="line329">329: </a><font color="#B22222">       -- input</font>
<a name="line330">330: </a><font color="#B22222">       ts        - pointer to ts</font>
<a name="line331">331: </a><font color="#B22222">       ts-&gt;ptime - current time</font>
<a name="line332">332: </a><font color="#B22222">       ts-&gt;time_step        - try this timestep</font>
<a name="line333">333: </a><font color="#B22222">       y1        - solution for this step</font>

<a name="line335">335: </a><font color="#B22222">       --output</font>
<a name="line336">336: </a><font color="#B22222">       y1        - suggested solution</font>
<a name="line337">337: </a><font color="#B22222">       y2        - check solution (runge - kutta second permutation)</font>
<a name="line338">338: </a><font color="#B22222">     */</font>
<a name="line339">339: </a>     TSRkqs(ts,ts-&gt;ptime,ts-&gt;time_step);
<a name="line340">340: </a>   <font color="#B22222">/* checking for maxerror */</font>
<a name="line341">341: </a>     <font color="#B22222">/* comparing difference to maxerror */</font>
<a name="line342">342: </a>     <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(rk-&gt;y2,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;norm);
<a name="line343">343: </a>     <font color="#B22222">/* modifying maxerror to satisfy this timestep */</font>
<a name="line344">344: </a>     rk-&gt;maxerror = rk-&gt;ferror * ts-&gt;time_step;
<a name="line345">345: </a>     <font color="#B22222">/* <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,"norm err: %f maxerror: %f dt: %f",norm,rk-&gt;maxerror,ts-&gt;time_step); */</font>

<a name="line347">347: </a>   <font color="#B22222">/* handling ok and not ok */</font>
<a name="line348">348: </a>     <font color="#4169E1">if</font> (norm &lt; rk-&gt;maxerror){
<a name="line349">349: </a>        <font color="#B22222">/* if ok: */</font>
<a name="line350">350: </a>        ierr=<A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(rk-&gt;y1,ts-&gt;vec_sol); <font color="#B22222">/* saves the suggested solution to current solution */</font>
<a name="line351">351: </a>        ts-&gt;ptime += ts-&gt;time_step; <font color="#B22222">/* storing the new current time */</font>
<a name="line352">352: </a>        rk-&gt;nok++;
<a name="line353">353: </a>        fac=5.0;
<a name="line354">354: </a>        <font color="#B22222">/* trying to save the vector */</font>
<a name="line355">355: </a>       <font color="#B22222">/* calling monitor */</font>
<a name="line356">356: </a>       TSMonitor(ts,ts-&gt;steps,ts-&gt;ptime,ts-&gt;vec_sol);
<a name="line357">357: </a>     } <font color="#4169E1">else</font>{
<a name="line358">358: </a>        <font color="#B22222">/* if not OK */</font>
<a name="line359">359: </a>        rk-&gt;nnok++;
<a name="line360">360: </a>        fac=1.0;
<a name="line361">361: </a>        ierr=<A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(ts-&gt;vec_sol,rk-&gt;y1);  <font color="#B22222">/* restores old solution */</font>
<a name="line362">362: </a>     }

<a name="line364">364: </a>     <font color="#B22222">/*Computing next stepsize. See page 167 in Solving ODE 1</font>
<a name="line365">365: </a><font color="#B22222">      *</font>
<a name="line366">366: </a><font color="#B22222">      * h_new = h * min( facmax , max( facmin , fac * (tol/err)^(1/(p+1)) ) )</font>
<a name="line367">367: </a><font color="#B22222">      * facmax set above</font>
<a name="line368">368: </a><font color="#B22222">      * facmin</font>
<a name="line369">369: </a><font color="#B22222">      */</font>
<a name="line370">370: </a>     dt_fac = exp(log((rk-&gt;maxerror) / norm) / ((rk-&gt;p) + 1) ) * 0.9 ;

<a name="line372">372: </a>     <font color="#4169E1">if</font> (dt_fac &gt; fac){
<a name="line373">373: </a>        <font color="#B22222">/*<A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,"changing fac %f\n",fac);*/</font>
<a name="line374">374: </a>        dt_fac = fac;
<a name="line375">375: </a>     }

<a name="line377">377: </a>     <font color="#B22222">/* computing new ts-&gt;time_step */</font>
<a name="line378">378: </a>     ts-&gt;time_step = ts-&gt;time_step * dt_fac;

<a name="line380">380: </a>     <font color="#4169E1">if</font> (ts-&gt;ptime+ts-&gt;time_step &gt; ts-&gt;max_time){
<a name="line381">381: </a>        ts-&gt;time_step = ts-&gt;max_time - ts-&gt;ptime;
<a name="line382">382: </a>     }

<a name="line384">384: </a>     <font color="#4169E1">if</font> (ts-&gt;time_step &lt; 1e-14){
<a name="line385">385: </a>        <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"Very small steps: %f\n"</font>,ts-&gt;time_step);
<a name="line386">386: </a>        ts-&gt;time_step = 1e-14;
<a name="line387">387: </a>     }

<a name="line389">389: </a>     <font color="#B22222">/* trying to purify h */</font>
<a name="line390">390: </a>     <font color="#B22222">/* (did not give any visible result) */</font>
<a name="line391">391: </a>     <font color="#B22222">/* ttmp = ts-&gt;ptime + ts-&gt;time_step;</font>
<a name="line392">392: </a><font color="#B22222">        ts-&gt;time_step = ttmp - ts-&gt;ptime; */</font>
<a name="line393">393: </a>
<a name="line394">394: </a>     <font color="#B22222">/* counting steps */</font>
<a name="line395">395: </a>     ts-&gt;steps++;
<a name="line396">396: </a>  }
<a name="line397">397: </a>
<a name="line398">398: </a>  ierr=<A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(rk-&gt;y1,ts-&gt;vec_sol);
<a name="line399">399: </a>  *steps += ts-&gt;steps;
<a name="line400">400: </a>  *ptime  = ts-&gt;ptime;
<a name="line401">401: </a>  <font color="#4169E1">return</font>(0);
<a name="line402">402: </a>}

<a name="line404">404: </a><font color="#B22222">/*------------------------------------------------------------*/</font>
<a name="line407">407: </a><strong><font color="#4169E1"><a name="TSDestroy_Rk"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSDestroy_Rk(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line408">408: </a>{
<a name="line409">409: </a>  TS_Rk          *rk = (TS_Rk*)ts-&gt;data;
<a name="line411">411: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i;

<a name="line413">413: </a>  <font color="#B22222">/* REMEMBER TO DESTROY ALL */</font>
<a name="line414">414: </a>
<a name="line416">416: </a>  <font color="#4169E1">if</font> (rk-&gt;y1) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(rk-&gt;y1);}
<a name="line417">417: </a>  <font color="#4169E1">if</font> (rk-&gt;y2) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(rk-&gt;y2);}
<a name="line418">418: </a>  <font color="#4169E1">if</font> (rk-&gt;tmp) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(rk-&gt;tmp);}
<a name="line419">419: </a>  <font color="#4169E1">if</font> (rk-&gt;tmp_y) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(rk-&gt;tmp_y);}
<a name="line420">420: </a>  <font color="#4169E1">for</font>(i=0;i&lt;rk-&gt;s;i++){
<a name="line421">421: </a>     <font color="#4169E1">if</font> (rk-&gt;k[i]) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(rk-&gt;k[i]);}
<a name="line422">422: </a>  }
<a name="line423">423: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(rk);
<a name="line424">424: </a>  <font color="#4169E1">return</font>(0);
<a name="line425">425: </a>}
<a name="line426">426: </a><font color="#B22222">/*------------------------------------------------------------*/</font>

<a name="line430">430: </a><strong><font color="#4169E1"><a name="TSSetFromOptions_Rk"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSSetFromOptions_Rk(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line431">431: </a>{
<a name="line432">432: </a>  TS_Rk          *rk = (TS_Rk*)ts-&gt;data;

<a name="line436">436: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsHead.html#PetscOptionsHead">PetscOptionsHead</A>(<font color="#666666">"RK ODE solver options"</font>);
<a name="line437">437: </a>    <A href="../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-ts_rk_tol"</font>,<font color="#666666">"Tolerance for convergence"</font>,<font color="#666666">"<A href="../../../../../docs/manualpages/TS/TSRKSetTolerance.html#TSRKSetTolerance">TSRKSetTolerance</A>"</font>,rk-&gt;tolerance,&amp;rk-&gt;tolerance,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line438">438: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsTail.html#PetscOptionsTail">PetscOptionsTail</A>();
<a name="line439">439: </a>  <font color="#4169E1">return</font>(0);
<a name="line440">440: </a>}

<a name="line444">444: </a><strong><font color="#4169E1"><a name="TSView_Rk"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSView_Rk(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line445">445: </a>{
<a name="line446">446: </a>   TS_Rk          *rk = (TS_Rk*)ts-&gt;data;
<a name="line448">448: </a>
<a name="line450">450: </a>   <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"  number of ok steps: %D\n"</font>,rk-&gt;nok);
<a name="line451">451: </a>   <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"  number of rejected steps: %D\n"</font>,rk-&gt;nnok);
<a name="line452">452: </a>   <font color="#4169E1">return</font>(0);
<a name="line453">453: </a>}

<a name="line455">455: </a><font color="#B22222">/* ------------------------------------------------------------ */</font>
<a name="line456">456: </a><font color="#B22222">/*MC</font>
<a name="line457">457: </a><font color="#B22222">      <A href="../../../../../docs/manualpages/TS/TS_RK.html#TS_RK">TS_RK</A> - ODE solver using the explicit Runge-Kutta methods</font>

<a name="line459">459: </a><font color="#B22222">   Options Database:</font>
<a name="line460">460: </a><font color="#B22222">.  -ts_rk_tol &lt;tol&gt; Tolerance for convergence</font>

<a name="line462">462: </a><font color="#B22222">  Contributed by: Asbjorn Hoiland Aarrestad, asbjorn@aarrestad.com, http://asbjorn.aarrestad.com/</font>

<a name="line464">464: </a><font color="#B22222">  Level: beginner</font>

<a name="line466">466: </a><font color="#B22222">.seealso:  <A href="../../../../../docs/manualpages/TS/TSCreate.html#TSCreate">TSCreate</A>(), <A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A>, <A href="../../../../../docs/manualpages/TS/TSSetType.html#TSSetType">TSSetType</A>(), <A href="../../../../../docs/manualpages/TS/TS_EULER.html#TS_EULER">TS_EULER</A>, <A href="../../../../../docs/manualpages/TS/TSRKSetTolerance.html#TSRKSetTolerance">TSRKSetTolerance</A>()</font>

<a name="line468">468: </a><font color="#B22222">M*/</font>

<a name="line473">473: </a><strong><font color="#4169E1"><a name="TSCreate_Rk"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  TSCreate_Rk(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line474">474: </a>{
<a name="line475">475: </a>  TS_Rk          *rk;

<a name="line479">479: </a>  ts-&gt;ops-&gt;setup           = TSSetUp_Rk;
<a name="line480">480: </a>  ts-&gt;ops-&gt;step            = TSStep_Rk;
<a name="line481">481: </a>  ts-&gt;ops-&gt;destroy         = TSDestroy_Rk;
<a name="line482">482: </a>  ts-&gt;ops-&gt;setfromoptions  = TSSetFromOptions_Rk;
<a name="line483">483: </a>  ts-&gt;ops-&gt;view            = TSView_Rk;

<a name="line485">485: </a>  <A href="../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(TS_Rk,&amp;rk);
<a name="line486">486: </a>  PetscLogObjectMemory(ts,<font color="#4169E1">sizeof</font>(TS_Rk));
<a name="line487">487: </a>  ts-&gt;data = (void*)rk;

<a name="line489">489: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)ts,<font color="#666666">"TSRKSetTolerance_C"</font>,<font color="#666666">"TSRKSetTolerance_RK"</font>,TSRKSetTolerance_RK);

<a name="line491">491: </a>  <font color="#4169E1">return</font>(0);
<a name="line492">492: </a>}




</pre>
</body>

</html>
